#!/bin/bash

rm -f results.output

HELAC="$1"
RUN="$2"
SUMPR="$HELAC"Summation_Processes/

$FC $SUMPR/processes.f
./a.out < infile

$FC $SUMPR/prodinput1.f

for j in *all
do
	echo $j > temporaryfile1
done

./a.out < temporaryfile1

for j in cinput*
do
	k=$((k+1))
done
echo $k > temporaryfile

sed -n 3p cinput1 >> temporaryfile

touch results.output

for i in `seq 1 $k`
do
	mkdir directory_$i
	cd directory_$i
	mv ../cinput$i input

	ln -s $LHAPDFSETS linkPDFsets
	ln -s $HELAC/cteq6l1.tbl .
	ln -s $HELAC/seed.input .

	$HELAC/main_mc_dp.exe < input > output

	test=`grep output -e"average estimate"`

	echo "test="$test

	if [ -n  "$test"  ]

	then
		grep output -e"average estimate" | awk '{print $4}' >> ../results.output
		grep output -e"variance estimate" | awk '{print $3}' >> ../results.output
		grep output -e"lwri:" | awk '{print $5}' >> ../results.output
		grep output -e"w=1" | awk '{print $5}' >> ../results.output
	else
		echo "0" >> ../results.output
		echo "0" >> ../results.output
		echo "0" >> ../results.output
		echo "0" >> ../results.output
	fi

	echo >> ../results.output

	rm -f data*
	unlink linkPDFsets
	unlink cteq6l1.tbl
	unlink seed.input
	gzip kine_*
	gzip even*out
	gzip output
	gzip err_file
	cd ..
	echo "Done run n. $i"
done

$FC $SUMPR/readoutput.f
./a.out >& $HELAC/$RUN/2/output
