      subroutine tohisto(w)
      include 'declare.h'
      
      include 'common_int.h'
      include 'common_phegas_mom.h'
      dimension p1(4),p2(4)
      double precision pt(20)
      integer ksort(20)
      
      pi=dacos(-dnou(1))       

      call  cmstolab

      do i=5,n
       pt(i-4)=dsqrt(pmom(i,1)**2+pmom(i,2)**2)
      enddo

c-----------------------------------------------
c       pt distributions
c -----------------------------------------------
      call alpsor(pt,n-4,ksort,2)
      print*,(pt(ksort(i)),i=1,n-4)
      print*,'-----------------------'
      
      call histo1(1,24,10.d0,250.d0,pt(ksort(4)),w)
      call histo1(2,19,10.d0,200.d0,pt(ksort(3)),w)
      call histo1(3,14,10.d0,150.d0,pt(ksort(2)),w)
      call histo1(4, 9,10.d0,100.d0,pt(ksort(1)),w)

      return
      end
      
      SUBROUTINE ALPSOR(A,N,K,IOPT)
C-----------------------------------------------------------------------
C     Sort A(N) into ascending order
C     IOPT = 1 : return sorted A and index array K
C     IOPT = 2 : return index array K only
C-----------------------------------------------------------------------
      DOUBLE PRECISION A(N),B(5000)
      INTEGER N,I,J,IOPT,K(N),IL(5000),IR(5000)
      IF (N.GT.5000) then
        write(*,*) 'Too many entries to sort in alpsrt, stop'
        stop
      endif
      if(n.le.0) return
      IL(1)=0
      IR(1)=0
      DO 10 I=2,N
      IL(I)=0
      IR(I)=0
      J=1
   2  IF(A(I).GT.A(J)) GOTO 5
   3  IF(IL(J).EQ.0) GOTO 4
      J=IL(J)
      GOTO 2
   4  IR(I)=-J
      IL(J)=I
      GOTO 10
   5  IF(IR(J).LE.0) GOTO 6
      J=IR(J)
      GOTO 2
   6  IR(I)=IR(J)
      IR(J)=I
  10  CONTINUE
      I=1
      J=1
      GOTO 8
  20  J=IL(J)
   8  IF(IL(J).GT.0) GOTO 20
   9  K(I)=J
      B(I)=A(J)
      I=I+1
      IF(IR(J)) 12,30,13
  13  J=IR(J)
      GOTO 8
  12  J=-IR(J)
      GOTO 9
  30  IF(IOPT.EQ.2) RETURN
      DO 31 I=1,N
  31  A(I)=B(I)
 999  END


