       subroutine qcdscale(scale)    
	    
       include 'declare.h'
       
       include 'common_phegas_mom.h'
       include 'common_masses.h'
       include 'common_int.h'

       dimension nue(4),numubar(4)
       double precision nue,numubar	    
       
c... construct pT or momenta of final state particles
       do i=3,n	    
	    if(ifl(i).eq.-2) then	       
	       pteplus = transverse(pmom(i,1:4))
	    elseif(ifl(i).eq.  1) then
	       nue(1:4) = pmom(i,1:4)
 	    elseif(ifl(i).eq.  6) then
	       ptmuminus = transverse(pmom(i,1:4))
	    elseif(ifl(i).eq. -5) then
	       numubar(1:4) = pmom(i,1:4)
	    elseif(ifl(i).eq. 12) then
	       ptb1 = transverse(pmom(i,1:4))
	    elseif(ifl(i).eq.-12) then
	       ptb2 = transverse(pmom(i,1:4))
	    elseif(abs(ifl(i)).eq.3.or.abs(ifl(i)).eq.4.or.
     .      abs(ifl(i)).eq.7.or.abs(ifl(i)).eq.8.or.
     .      abs(ifl(i)).eq.35) then
	       ptjet = transverse(pmom(i,1:4))
	    endif
       enddo

c... pT miss
	ptmiss = dsqrt((nue(1)+numubar(1))**2
     .         + (nue(2)+numubar(2))**2)

c... mu= H_T/2 (dynamical scale choice)
	scale = pTeplus+ptmuminus+ptb1+ptb2+ptjet+ptmiss 
	scale = scale/2d0

c... top quark mass (fixed scale choice)    
c       scale = parmas(11)

       return
       end
